Index: issm/trunk/src/c/classes/objects/Elements/Tria.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Elements/Tria.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Elements/Tria.cpp	(revision 13975)
@@ -42,6 +42,5 @@
 	:TriaRef(nummodels)
 	,TriaHook(nummodels,index+1,iomodel){
-		
-		int i;
+
 		/*id: */
 		this->id=tria_id;
@@ -127,12 +126,11 @@
 void  Tria::AverageOntoPartition(Vector<IssmDouble>* partition_contributions,Vector<IssmDouble>* partition_areas,IssmDouble* vertex_response,IssmDouble* qmu_part){
 
-	bool      already=false;
-	int       i,j;
-	int       partition[NUMVERTICES];
-	int       offsetsid[NUMVERTICES];
-	int       offsetdof[NUMVERTICES];
-	IssmDouble    area;
-	IssmDouble    mean;
-	IssmDouble    values[3];
+	bool       already = false;
+	int        i,j;
+	int        partition[NUMVERTICES];
+	int        offsetsid[NUMVERTICES];
+	int        offsetdof[NUMVERTICES];
+	IssmDouble area;
+	IssmDouble mean;
 
 	/*First, get the area: */
@@ -140,6 +138,6 @@
 
 	/*Figure out the average for this element: */
-	this->GetSidList(&offsetsid[0]);
-	this->GetDofList1(&offsetdof[0]);
+	this->GetVertexSidList(&offsetsid[0]);
+	this->GetVertexPidList(&offsetdof[0]);
 	mean=0;
 	for(i=0;i<NUMVERTICES;i++){
@@ -164,4 +162,55 @@
 }
 /*}}}*/
+/*FUNCTION Tria::SetwiseNodeConnectivity{{{*/
+void Tria::SetwiseNodeConnectivity(int* pd_nz,int* po_nz,Node* node,bool* flags,int set1_enum,int set2_enum){
+
+	/*Output */
+	int d_nz = 0;
+	int o_nz = 0;
+
+	/*Loop over all nodes*/
+	for(int i=0;i<3;i++){
+
+		if(!flags[this->nodes[i]->Sid()]){
+
+			/*flag current node so that no other element processes it*/
+			flags[this->nodes[i]->Sid()]=true;
+
+			/*if node is clone, we have an off-diagonal non-zero, else it is a diagonal non-zero*/
+			switch(set2_enum){
+				case FsetEnum:
+					if(nodes[i]->indexing.fsize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				case GsetEnum:
+					if(nodes[i]->indexing.gsize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				case SsetEnum:
+					if(nodes[i]->indexing.ssize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				default: _error_("not supported");
+			}
+		}
+	}
+
+	/*Assign output pointers: */
+	*pd_nz=d_nz;
+	*po_nz=o_nz;
+}
+/*}}}*/
 /*FUNCTION Tria::CreateKMatrix {{{*/
 void  Tria::CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs,Vector<IssmDouble>* df){
@@ -175,5 +224,5 @@
 	_assert_(this->nodes && this->material && this->matpar && this->parameters && this->inputs);
 	/*}}}*/
-	
+
 	/*Skip if water element*/
 	if(IsOnWater()) return;
@@ -231,5 +280,4 @@
 
 	/*Intermediaries */
-	int        i,j,ig;
 	IssmDouble heatcapacity,latentheat;
 	IssmDouble Jdet,D_scalar;
@@ -248,5 +296,5 @@
 	/* Start looping on the number of gauss  (nodes on the bedrock) */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -290,18 +338,17 @@
 	/*Intermediaries */
 	int        stabilization;
-	int        i,j,ig,dim;
-	IssmDouble     Jdettria,DL_scalar,dt,h;
-	IssmDouble     vel,vx,vy,dvxdx,dvydy;
-	IssmDouble     dvx[2],dvy[2];
-	IssmDouble     v_gauss[2]={0.0};
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     L[NUMVERTICES];
-	IssmDouble     B[2][NUMVERTICES];
-	IssmDouble     Bprime[2][NUMVERTICES];
-	IssmDouble     K[2][2]                        ={0.0};
-	IssmDouble     KDL[2][2]                      ={0.0};
-	IssmDouble     DL[2][2]                        ={0.0};
-	IssmDouble     DLprime[2][2]                   ={0.0};
-	GaussTria *gauss=NULL;
+	int        dim;
+	IssmDouble Jdettria,DL_scalar,dt,h;
+	IssmDouble vel,vx,vy,dvxdx,dvydy;
+	IssmDouble dvx[2],dvy[2];
+	IssmDouble v_gauss[2]={0.0};
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble L[NUMVERTICES];
+	IssmDouble B[2][NUMVERTICES];
+	IssmDouble Bprime[2][NUMVERTICES];
+	IssmDouble K[2][2]                        ={0.0};
+	IssmDouble KDL[2][2]                      ={0.0};
+	IssmDouble DL[2][2]                        ={0.0};
+	IssmDouble DLprime[2][2]                   ={0.0};
 
 	/*Initialize Element matrix*/
@@ -326,6 +373,6 @@
 
 	/* Start  looping on the number of gaussian points: */
-	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	GaussTria *gauss=new GaussTria(2);
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -409,13 +456,13 @@
 
 	/*Intermediaries */
-	int        i,j,ig,dim;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     Jdettria,dt,vx,vy;
-	IssmDouble     L[NUMVERTICES];
-	IssmDouble     B[2][NUMVERTICES];
-	IssmDouble     Bprime[2][NUMVERTICES];
-	IssmDouble     DL[2][2]={0.0};
-	IssmDouble     DLprime[2][2]={0.0};
-	IssmDouble     DL_scalar;
+	int        dim;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble Jdettria,dt,vx,vy;
+	IssmDouble L[NUMVERTICES];
+	IssmDouble B[2][NUMVERTICES];
+	IssmDouble Bprime[2][NUMVERTICES];
+	IssmDouble DL[2][2]={0.0};
+	IssmDouble DLprime[2][2]={0.0};
+	IssmDouble DL_scalar;
 	GaussTria  *gauss=NULL;
 
@@ -440,5 +487,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -499,5 +546,5 @@
 
 		gauss->GaussPoint(ig);
-		
+
 		GetJacobianDeterminant2d(&Jdet, &xyz_list[0][0],gauss);
 		D=gauss->weight*Jdet;
@@ -528,5 +575,5 @@
 	_assert_(this->nodes && this->material && this->matpar && this->parameters && this->inputs);
 	/*}}}*/
-	
+
 	/*Skip if water element*/
 	if(IsOnWater()) return;
@@ -597,9 +644,8 @@
 
 	/*Intermediaries */
-	int        i,j,ig;
-	IssmDouble     Jdettria,dt;
-	IssmDouble     surface_mass_balance_g,basal_melting_g,basal_melting_correction_g,thickness_g;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     L[NUMVERTICES];
+	IssmDouble Jdettria,dt;
+	IssmDouble surface_mass_balance_g,basal_melting_g,basal_melting_correction_g,thickness_g;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble L[NUMVERTICES];
 	GaussTria* gauss=NULL;
 
@@ -618,5 +664,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for(ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -633,5 +679,5 @@
 		 basal_melting_correction_g=0.;
 
-		for(i=0;i<numdof;i++) pe->values[i]+=Jdettria*gauss->weight*(thickness_g+dt*(surface_mass_balance_g-basal_melting_g-basal_melting_correction_g))*L[i];
+		for(int i=0;i<numdof;i++) pe->values[i]+=Jdettria*gauss->weight*(thickness_g+dt*(surface_mass_balance_g-basal_melting_g-basal_melting_correction_g))*L[i];
 	}
 
@@ -648,9 +694,8 @@
 
 	/*Intermediaries */
-	int        i,j,ig;
-	IssmDouble     Jdettria,dt;
-	IssmDouble     surface_mass_balance_g,basal_melting_g,thickness_g;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     L[NUMVERTICES];
+	IssmDouble Jdettria,dt;
+	IssmDouble surface_mass_balance_g,basal_melting_g,thickness_g;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble L[NUMVERTICES];
 	GaussTria* gauss=NULL;
 
@@ -667,5 +712,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for(ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -678,5 +723,5 @@
 		thickness_input->GetInputValue(&thickness_g,gauss);
 
-		for(i=0;i<numdof;i++) pe->values[i]+=Jdettria*gauss->weight*(thickness_g+dt*(surface_mass_balance_g-basal_melting_g))*L[i];
+		for(int i=0;i<numdof;i++) pe->values[i]+=Jdettria*gauss->weight*(thickness_g+dt*(surface_mass_balance_g-basal_melting_g))*L[i];
 	}
 
@@ -691,12 +736,12 @@
 	/*Constants*/
 	const int    numdof=NDOF1*NUMVERTICES;
-	
+
 	/*Intermediaries */
-	int        i,j,ig;
+	int        i;
 	int        analysis_type;
-	IssmDouble     Jdet;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     slope[2];
-	IssmDouble     basis[3];
+	IssmDouble Jdet;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble slope[2];
+	IssmDouble basis[3];
 	GaussTria* gauss=NULL;
 
@@ -714,8 +759,8 @@
 		slope_input=inputs->GetInput(BedEnum);     _assert_(slope_input);
 	}
-		
+
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for(ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -785,5 +830,4 @@
 void  Tria::ComputeStressTensor(){
 
-	int         iv;
 	IssmDouble      xyz_list[NUMVERTICES][3];
 	IssmDouble      pressure,viscosity;
@@ -820,5 +864,5 @@
 		sigma_xy[iv]=2*viscosity*epsilon[2];
 	}
-	
+
 	/*Add Stress tensor components into inputs*/
 	this->inputs->AddInput(new TriaP1Input(StressTensorxxEnum,&sigma_xx[0]));
@@ -835,5 +879,5 @@
 /*FUNCTION Tria::Configure {{{*/
 void  Tria::Configure(Elements* elementsin, Loads* loadsin, DataSet* nodesin, Materials* materialsin, Parameters* parametersin){
-	
+
 	/*go into parameters and get the analysis_counter: */
 	int analysis_counter;
@@ -894,5 +938,5 @@
 	_printLine_("neighboor sids: ");
 	_printLine_(" " << horizontalneighborsids[0] << " " << horizontalneighborsids[1] << " " << horizontalneighborsids[2]);
-	
+
 	return;
 }
@@ -946,5 +990,5 @@
 	this->parameters->FindParam(&Delta18oSurfaceLgm,SurfaceforcingsDelta18oSurfaceEnum,(finaltime-(21000*yts)));
 	this->parameters->FindParam(&Delta18oSurfaceTime,SurfaceforcingsDelta18oSurfaceEnum,time);
-	
+
 	/*Compute the temperature and precipitation*/
 	for(int iv=0;iv<NUMVERTICES;iv++){
@@ -1027,5 +1071,5 @@
 	x2=xyz_list[1][0]; y2=xyz_list[1][1];
 	x3=xyz_list[2][0]; y3=xyz_list[2][1];
- 
+
 	_assert_(x2*y3 - y2*x3 + x1*y2 - y1*x2 + x3*y1 - y3*x1>0);
 	return (x2*y3 - y2*x3 + x1*y2 - y1*x2 + x3*y1 - y3*x1)/2;
@@ -1055,12 +1099,4 @@
 }
 /*}}}*/
-/*FUNCTION Tria::GetDofList1 {{{*/
-void  Tria::GetDofList1(int* doflist){
-
-	int i;
-	for(i=0;i<3;i++) doflist[i]=nodes[i]->GetDofList1();
-
-}
-/*}}}*/
 /*FUNCTION Tria::GetElementType {{{*/
 int Tria::GetElementType(){
@@ -1090,10 +1126,32 @@
 }
 /*}}}*/
+/*FUNCTION Tria::GetNodesSidList{{{*/
+void Tria::GetNodesSidList(int* sidlist){
+
+	_assert_(sidlist);
+	_assert_(nodes);
+
+	for(int i=0;i<NUMVERTICES;i++){
+		sidlist[i]=nodes[i]->Sid();
+	}
+}
+/*}}}*/
+/*FUNCTION Tria::GetNumberOfNodes{{{*/
+int Tria::GetNumberOfNodes(void){
+
+	if(this->nodes==NULL) return 0;
+
+	switch(this->element_type){
+		case P1Enum:
+			return 3;
+		case P1DGEnum:
+			return 3;
+		default:
+			_error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+	}
+}
+/*}}}*/
 /*FUNCTION Tria::GetInputListOnVertices(IssmDouble* pvalue,int enumtype) {{{*/
 void Tria::GetInputListOnVertices(IssmDouble* pvalue,int enumtype){
-
-	/*Intermediaries*/
-	IssmDouble     value[NUMVERTICES];
-	GaussTria *gauss              = NULL;
 
 	/*Recover input*/
@@ -1105,5 +1163,5 @@
 
 	/* Start looping on the number of vertices: */
-	gauss=new GaussTria();
+	GaussTria* gauss=new GaussTria();
 	for (int iv=0;iv<NUMVERTICES;iv++){
 		gauss->GaussVertex(iv);
@@ -1118,6 +1176,4 @@
 void Tria::GetInputListOnVertices(IssmDouble* pvalue,int enumtype,IssmDouble defaultvalue){
 
-	IssmDouble     value[NUMVERTICES];
-	GaussTria *gauss = NULL;
 	Input     *input = inputs->GetInput(enumtype);
 
@@ -1127,16 +1183,14 @@
 	/* Start looping on the number of vertices: */
 	if (input){
-		gauss=new GaussTria();
+		GaussTria* gauss=new GaussTria();
 		for (int iv=0;iv<NUMVERTICES;iv++){
 			gauss->GaussVertex(iv);
 			input->GetInputValue(&pvalue[iv],gauss);
 		}
+		delete gauss;
 	}
 	else{
 		for (int iv=0;iv<NUMVERTICES;iv++) pvalue[iv]=defaultvalue;
 	}
-
-	/*clean-up*/
-	delete gauss;
 }
 /*}}}*/
@@ -1144,6 +1198,4 @@
 void Tria::GetInputListOnVertices(IssmDouble* pvalue,int enumtype,IssmDouble defaultvalue,int index){
 
-	IssmDouble     value[NUMVERTICES];
-	GaussTria *gauss = NULL;
 	Input     *input = inputs->GetInput(enumtype);
 
@@ -1153,16 +1205,14 @@
 	/* Start looping on the number of vertices: */
 	if (input){
-		gauss=new GaussTria();
+		GaussTria* gauss=new GaussTria();
 		for (int iv=0;iv<NUMVERTICES;iv++){
 			gauss->GaussVertex(iv);
 			input->GetInputValue(&pvalue[iv],gauss,index);
 		}
+		delete gauss;
 	}
 	else{
 		for (int iv=0;iv<NUMVERTICES;iv++) pvalue[iv]=defaultvalue;
 	}
-
-	/*clean-up*/
-	delete gauss;
 }
 /*}}}*/
@@ -1180,7 +1230,15 @@
 }
 /*}}}*/
-/*FUNCTION Tria::GetSidList {{{*/
-void  Tria::GetSidList(int* sidlist){
-	for(int i=0;i<NUMVERTICES;i++) sidlist[i]=nodes[i]->GetSidList();
+/*FUNCTION Tria::GetVertexPidList {{{*/
+void  Tria::GetVertexPidList(int* doflist){
+
+	int i;
+	for(i=0;i<3;i++) doflist[i]=nodes[i]->GetVertexPid();
+
+}
+/*}}}*/
+/*FUNCTION Tria::GetVertexSidList {{{*/
+void  Tria::GetVertexSidList(int* sidlist){
+	for(int i=0;i<NUMVERTICES;i++) sidlist[i]=nodes[i]->GetVertexSid();
 }
 /*}}}*/
@@ -1243,5 +1301,5 @@
 void  Tria::GetVectorFromInputs(Vector<IssmDouble>* vector,int input_enum){
 
-	int doflist1[NUMVERTICES];
+	int vertexpidlist[NUMVERTICES];
 
 	/*Get out if this is not an element input*/
@@ -1249,5 +1307,5 @@
 
 	/*Prepare index list*/
-	this->GetDofList1(&doflist1[0]);
+	this->GetVertexPidList(&vertexpidlist[0]);
 
 	/*Get input (either in element or material)*/
@@ -1256,5 +1314,5 @@
 
 	/*We found the enum.  Use its values to fill into the vector, using the vertices ids: */
-	input->GetVectorFromInputs(vector,&doflist1[0]);
+	input->GetVectorFromInputs(vector,&vertexpidlist[0]);
 }
 /*}}}*/
@@ -1268,9 +1326,9 @@
 	}
 	if(interp==P1Enum){
-		int doflist1[NUMVERTICES];
+		int vertexpidlist[NUMVERTICES];
 		int connectivity[NUMVERTICES];
-		this->GetSidList(&doflist1[0]);
+		this->GetVertexSidList(&vertexpidlist[0]);
 		this->GetConnectivityList(&connectivity[0]);
-		elementresult->GetVectorFromResults(vector,&doflist1[0],&connectivity[0],NUMVERTICES);
+		elementresult->GetVectorFromResults(vector,&vertexpidlist[0],&connectivity[0],NUMVERTICES);
 	}
 	else if(interp==P0Enum){
@@ -1284,5 +1342,5 @@
 /*FUNCTION Tria::Id {{{*/
 int    Tria::Id(){
-	
+
 	return id;
 
@@ -1291,5 +1349,5 @@
 /*FUNCTION Tria::Sid {{{*/
 int    Tria::Sid(){
-	
+
 	return sid;
 
@@ -1392,10 +1450,11 @@
 void  Tria::InputToResult(int enum_type,int step,IssmDouble time){
 
-	int    i;
 	Input *input = NULL;	
 
 	/*Go through all the input objects, and find the one corresponding to enum_type, if it exists: */
-	if (enum_type==MaterialsRheologyBbarEnum || enum_type==MaterialsRheologyZbarEnum) input=this->material->inputs->GetInput(enum_type);
-	else input=this->inputs->GetInput(enum_type);
+	if (enum_type==MaterialsRheologyBbarEnum || enum_type==MaterialsRheologyZbarEnum)
+	 input=this->material->inputs->GetInput(enum_type);
+	else
+	 input=this->inputs->GetInput(enum_type);
 	//if (!input) _error_("Input " << EnumToStringx(enum_type) << " not found in tria->inputs");
 	if(!input)return;
@@ -1404,5 +1463,5 @@
 	 * object out of the input, with the additional step and time information: */
 	this->results->AddObject((Object*)input->SpawnResult(step,time));
-	
+
 	#ifdef _HAVE_CONTROL_
 	if(input->ObjectEnum()==ControlInputEnum){
@@ -1452,5 +1511,5 @@
 	IssmDouble yts;
 	int        num_cm_responses;
-   
+
 	/*Get parameters: */
 	iomodel->Constant(&yts,ConstantsYtsEnum); 
@@ -1687,5 +1746,5 @@
 			/*Get values on the 3 vertices*/
 			for (int i=0;i<3;i++){
-				values[i]=vector[this->nodes[i]->GetVertexDof()];
+				values[i]=vector[this->nodes[i]->GetVertexPid()];
 			}
 
@@ -1719,5 +1778,5 @@
 	/*Check that name is an element input*/
 	if (!IsInput(name)) return;
-	
+
 	if ((code==5) || (code==1)){ //boolean
 		this->inputs->AddInput(new BoolInput(name,reCast<bool>(scalar)));
@@ -1746,5 +1805,4 @@
 	int    numberofelements;
 	IssmDouble yts;
-
 
 	/*Fetch parameters: */
@@ -1861,5 +1919,5 @@
 /*FUNCTION Tria::IsOnBed {{{*/
 bool Tria::IsOnBed(){
-	
+
 	bool onbed;
 	inputs->GetInputValue(&onbed,MeshElementonbedEnum);
@@ -1967,5 +2025,5 @@
 void  Tria::MigrateGroundingLine(IssmDouble* old_floating_ice,IssmDouble* sheet_ungrounding){
 
-	int     i,migration_style,unground;
+	int     i,migration_style;
 	bool    elementonshelf = false;
 	IssmDouble  bed_hydro,yts,gl_melting_rate;
@@ -1976,4 +2034,5 @@
 	/*Recover info at the vertices: */
 	parameters->FindParam(&migration_style,GroundinglineMigrationEnum);
+	parameters->FindParam(&gl_melting_rate,GroundinglineMeltingRateEnum);
 	parameters->FindParam(&yts,ConstantsYtsEnum);
 	GetInputListOnVertices(&h[0],ThicknessEnum);
@@ -1984,5 +2043,5 @@
 	rho_ice=matpar->GetRhoIce();
 	density=rho_ice/rho_water;
-	
+
 	/*go through vertices, and update inputs, considering them to be TriaVertex type: */
 	for(i=0;i<NUMVERTICES;i++){
@@ -2025,5 +2084,5 @@
 		}
 	}
-	
+
    /*Add basal melting rate if element just ungrounded*/
 	if(!this->IsFloating() && elementonshelf==true){
@@ -2038,10 +2097,4 @@
 	this->inputs->AddInput(new TriaP1Input(SurfaceEnum,&s[0]));
 	this->inputs->AddInput(new TriaP1Input(BedEnum,&b[0]));
-}
-/*}}}*/
-/*FUNCTION Tria::MyRank {{{*/
-int    Tria::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
 }
 /*}}}*/
@@ -2087,5 +2140,5 @@
 	/*recover pointer: */
 	row=*prow;
-		
+
 	for(i=0;i<3;i++) vertices_ids[i]=nodes[i]->GetVertexId(); //vertices id start at column 3 of the patch.
 
@@ -2269,4 +2322,6 @@
 	IssmDouble b_neg[NUMVERTICES];				// Hs-SMB relation paremeter
 	IssmDouble Hc[NUMVERTICES];					// elevation of transition between accumulation regime and ablation regime
+	IssmDouble Href[NUMVERTICES];					// reference elevation from which deviations are used to calculate the SMB adjustment
+	IssmDouble Smbref[NUMVERTICES];				// reference SMB to which deviations are added
 	IssmDouble smb_pos_max[NUMVERTICES];		// maximum SMB value in the accumulation regime
 	IssmDouble smb_pos_min[NUMVERTICES];		// minimum SMB value in the accumulation regime
@@ -2279,4 +2334,6 @@
 	/*Recover SmbGradients*/
 	GetInputListOnVertices(&Hc[0],SurfaceforcingsHcEnum);
+	GetInputListOnVertices(&Href[0],SurfaceforcingsHrefEnum);
+	GetInputListOnVertices(&Smbref[0],SurfaceforcingsSmbrefEnum);
 	GetInputListOnVertices(&smb_pos_max[0],SurfaceforcingsSmbPosMaxEnum);
 	GetInputListOnVertices(&smb_pos_min[0],SurfaceforcingsSmbPosMinEnum);
@@ -2285,5 +2342,5 @@
 	GetInputListOnVertices(&a_neg[0],SurfaceforcingsANegEnum);
 	GetInputListOnVertices(&b_neg[0],SurfaceforcingsBNegEnum);
-	
+
    /*Recover surface elevatio at vertices: */
 	GetInputListOnVertices(&h[0],ThicknessEnum);
@@ -2293,17 +2350,26 @@
    rho_ice=matpar->GetRhoIce();
    rho_water=matpar->GetRhoFreshwater();
-			
+
    // loop over all vertices
    for(i=0;i<NUMVERTICES;i++){
      if(s[i]>Hc[i]){
-	    smb[i]=a_pos[i]+b_pos[i]*s[i];
-		 if(smb[i]>smb_pos_max[i]){smb[i]=smb_pos_max[i];}
-		 if(smb[i]<smb_pos_min[i]){smb[i]=smb_pos_min[i];}
+		  if(Href[i]>Hc[i]){smb[i]=Smbref[i]+b_pos[i]*(s[i]-Href[i]);}
+		  if(Href[i]<=Hc[i]){smb[i]=a_pos[i]+b_pos[i]*s[i];}
+		  if(smb[i]>smb_pos_max[i]){smb[i]=smb_pos_max[i];}
+		  if(smb[i]<smb_pos_min[i]){smb[i]=smb_pos_min[i];}
 	  }
 	  else{
-	    smb[i]=a_neg[i]+b_neg[i]*s[i];
+		  if(Href[i]>Hc[i]){smb[i]=a_neg[i]+b_neg[i]*s[i];}
+		  if(Href[i]<=Hc[i]){smb[i]=Smbref[i]+b_neg[i]*(s[i]-Href[i]);}
 	  }
 	  smb[i]=smb[i]/rho_ice;      // SMB in m/y ice		
-	}  //end of the loop over the vertices
+  /*   printf("s %e \n",s[i]); 
+     printf("Hsref %e \n",Href[i]); 
+     printf("Hc %e \n",Hc[i]); 
+     printf("Smbref %e \n",Smbref[i]); 
+     printf("b_neg %e \n",b_neg[i]); 
+     printf("smb %e \n",smb[i]); 
+	  _error_("stop-in-code"); */
+		}  //end of the loop over the vertices
 	  /*Update inputs*/
 	  this->inputs->AddInput(new TriaP1Input(SurfaceforcingsMassBalanceEnum,&smb[0]));
@@ -2312,5 +2378,5 @@
 /*FUNCTION Tria::SetCurrentConfiguration {{{*/
 void  Tria::SetCurrentConfiguration(Elements* elementsin, Loads* loadsin, DataSet* nodesin, Materials* materialsin, Parameters* parametersin){
-	
+
 	/*go into parameters and get the analysis_counter: */
 	int analysis_counter;
@@ -2533,5 +2599,5 @@
 		if (reCast<bool>(vertices_potentially_ungrounding[nodes[i]->Sid()])){
 			vec_nodes_on_iceshelf->SetValue(nodes[i]->Sid(),1,INS_VAL);
-		
+
 			/*If node was not on ice shelf, we flipped*/
 			if(nodes_on_iceshelf[nodes[i]->Sid()]==0){
@@ -2574,13 +2640,12 @@
 IssmDouble Tria::MassFlux( IssmDouble* segment,bool process_units){
 
-	const int    numdofs=2;
-
-	int        i,dim;
-	IssmDouble     mass_flux=0;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     normal[2];
-	IssmDouble     length,rho_ice;
-	IssmDouble     x1,y1,x2,y2,h1,h2;
-	IssmDouble     vx1,vx2,vy1,vy2;
+	const int  numdofs=2;
+	int        dim;
+	IssmDouble mass_flux=0;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble normal[2];
+	IssmDouble length,rho_ice;
+	IssmDouble x1,y1,x2,y2,h1,h2;
+	IssmDouble vx1,vx2,vy1,vy2;
 	GaussTria* gauss_1=NULL;
 	GaussTria* gauss_2=NULL;
@@ -2842,8 +2907,8 @@
 	smb_input->GetInputAverage(&smb);																								// average smb on element in m ice s-1
    Total_Smb=rho_ice*base*smb;																											// smb on element in kg s-1
-	
+
 	/*Process units: */
 	Total_Smb=UnitConversion(Total_Smb,IuToExtEnum,TotalSmbEnum);																// smb on element in GigaTon yr-1
-	
+
 	/*Return: */
 	return Total_Smb;
@@ -2860,5 +2925,5 @@
 	ElementMatrix* Ke2=CreateKMatrixDiagnosticMacAyealFriction();
 	ElementMatrix* Ke =new ElementMatrix(Ke1,Ke2);
-	
+
 	/*clean-up and return*/
 	delete Ke1;
@@ -2874,13 +2939,13 @@
 
 	/*Intermediaries*/
-	int        i,j,ig;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     viscosity,newviscosity,oldviscosity;
-	IssmDouble     viscosity_overshoot,thickness,Jdet;
-	IssmDouble     epsilon[3],oldepsilon[3];    /* epsilon=[exx,eyy,exy];    */
-	IssmDouble     B[3][numdof];
-	IssmDouble     Bprime[3][numdof];
-	IssmDouble     D[3][3]   = {0.0};
-	IssmDouble     D_scalar;
+	int        i,j;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble viscosity,newviscosity,oldviscosity;
+	IssmDouble viscosity_overshoot,thickness,Jdet;
+	IssmDouble epsilon[3],oldepsilon[3];    /* epsilon=[exx,eyy,exy];    */
+	IssmDouble B[3][numdof];
+	IssmDouble Bprime[3][numdof];
+	IssmDouble D[3][3]   = {0.0};
+	IssmDouble D_scalar;
 	GaussTria *gauss = NULL;
 
@@ -2899,5 +2964,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -2938,15 +3003,15 @@
 
 	/*Intermediaries*/
-	int        i,j,ig;
+	int        i,j;
 	int        analysis_type;
-	IssmDouble     MAXSLOPE  = .06; // 6 %
-	IssmDouble     MOUNTAINKEXPONENT = 10;
-	IssmDouble     slope_magnitude,alpha2;
-	IssmDouble     Jdet;
-	IssmDouble     L[2][numdof];
-	IssmDouble     DL[2][2]  = {{ 0,0 },{0,0}};
-	IssmDouble     DL_scalar;
-	IssmDouble     slope[2]  = {0.0,0.0};
-	IssmDouble     xyz_list[NUMVERTICES][3];
+	IssmDouble MAXSLOPE  = .06; // 6 %
+	IssmDouble MOUNTAINKEXPONENT = 10;
+	IssmDouble slope_magnitude,alpha2;
+	IssmDouble Jdet;
+	IssmDouble L[2][numdof];
+	IssmDouble DL[2][2]  = {{ 0,0 },{0,0}};
+	IssmDouble DL_scalar;
+	IssmDouble slope[2]  = {0.0,0.0};
+	IssmDouble xyz_list[NUMVERTICES][3];
 	Friction  *friction = NULL;
 	GaussTria *gauss    = NULL;
@@ -2969,5 +3034,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -2984,5 +3049,5 @@
 		DL_scalar=alpha2*gauss->weight*Jdet;
 		for (i=0;i<2;i++) DL[i][i]=DL_scalar;
-		
+
 		TripleMultiply( &L[0][0],2,numdof,1,
 					&DL[0][0],2,2,0,
@@ -3028,11 +3093,11 @@
 
 	/*Intermediaries */
-	int            i,j,ig;
-	IssmDouble         driving_stress_baseline,thickness;
-	IssmDouble         Jdet;
-	IssmDouble         xyz_list[NUMVERTICES][3];
-	IssmDouble         slope[2];
-	IssmDouble         basis[3];
-	IssmDouble         pe_g_gaussian[numdof];
+	int            i,j;
+	IssmDouble     driving_stress_baseline,thickness;
+	IssmDouble     Jdet;
+	IssmDouble     xyz_list[NUMVERTICES][3];
+	IssmDouble     slope[2];
+	IssmDouble     basis[3];
+	IssmDouble     pe_g_gaussian[numdof];
 	GaussTria*     gauss=NULL;
 
@@ -3048,5 +3113,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for(ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -3132,14 +3197,14 @@
 
 	/*Intermediaries */
-	int        i,j,ig;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     Jdet,thickness;
-	IssmDouble     eps1dotdphii,eps1dotdphij;
-	IssmDouble     eps2dotdphii,eps2dotdphij;
-	IssmDouble     mu_prime;
-	IssmDouble     epsilon[3];/* epsilon=[exx,eyy,exy];*/
-	IssmDouble     eps1[2],eps2[2];
-	IssmDouble     phi[NUMVERTICES];
-	IssmDouble     dphi[2][NUMVERTICES];
+	int        i,j;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble Jdet,thickness;
+	IssmDouble eps1dotdphii,eps1dotdphij;
+	IssmDouble eps2dotdphii,eps2dotdphij;
+	IssmDouble mu_prime;
+	IssmDouble epsilon[3];/* epsilon=[exx,eyy,exy];*/
+	IssmDouble eps1[2],eps2[2];
+	IssmDouble phi[NUMVERTICES];
+	IssmDouble dphi[2][NUMVERTICES];
 	GaussTria *gauss=NULL;
 
@@ -3155,5 +3220,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -3271,5 +3336,5 @@
 /*FUNCTION Tria::InputUpdateFromSolutionDiagnosticHoriz {{{*/
 void  Tria::InputUpdateFromSolutionDiagnosticHoriz(IssmDouble* solution){
-	
+
 	const int numdof=NDOF2*NUMVERTICES;
 
@@ -3284,5 +3349,5 @@
 	IssmDouble    pressure[NUMVERTICES];
 	IssmDouble    thickness[NUMVERTICES];
-	
+
 	/*Get dof list: */
 	GetDofList(&doflist,NoneApproximationEnum,GsetEnum);
@@ -3334,7 +3399,7 @@
 /*FUNCTION Tria::InputUpdateFromSolutionDiagnosticHutter {{{*/
 void  Tria::InputUpdateFromSolutionDiagnosticHutter(IssmDouble* solution){
-	
+
 	const int numdof=NDOF2*NUMVERTICES;
-	
+
 	int       i;
 	int*      doflist=NULL;
@@ -3347,5 +3412,5 @@
 	IssmDouble    pressure[NUMVERTICES];
 	IssmDouble    thickness[NUMVERTICES];
-	
+
 	/*Get dof list: */
 	GetDofList(&doflist,NoneApproximationEnum,GsetEnum);
@@ -3432,5 +3497,5 @@
 void Tria::ControlInputGetGradient(Vector<IssmDouble>* gradient,int enum_type,int control_index){
 
-	int doflist1[NUMVERTICES];
+	int vertexpidlist[NUMVERTICES];
 	Input* input=NULL;
 
@@ -3444,6 +3509,6 @@
 	if (input->ObjectEnum()!=ControlInputEnum) _error_("Input " << EnumToStringx(enum_type) << " is not a ControlInput");
 
-	GradientIndexing(&doflist1[0],control_index);
-	((ControlInput*)input)->GetGradient(gradient,&doflist1[0]);
+	GradientIndexing(&vertexpidlist[0],control_index);
+	((ControlInput*)input)->GetGradient(gradient,&vertexpidlist[0]);
 
 }/*}}}*/
@@ -3467,5 +3532,5 @@
 void Tria::ControlInputSetGradient(IssmDouble* gradient,int enum_type,int control_index){
 
-	int    doflist1[NUMVERTICES];
+	int    vertexpidlist[NUMVERTICES];
 	IssmDouble grad_list[NUMVERTICES];
 	Input* grad_input=NULL;
@@ -3481,6 +3546,6 @@
 	if (input->ObjectEnum()!=ControlInputEnum) _error_("Input " << EnumToStringx(enum_type) << " is not a ControlInput");
 
-	GradientIndexing(&doflist1[0],control_index);
-	for(int i=0;i<NUMVERTICES;i++) grad_list[i]=gradient[doflist1[i]];
+	GradientIndexing(&vertexpidlist[0],control_index);
+	for(int i=0;i<NUMVERTICES;i++) grad_list[i]=gradient[vertexpidlist[i]];
 	grad_input=new TriaP1Input(GradientEnum,grad_list);
 
@@ -3555,16 +3620,16 @@
 void  Tria::GradjBGradient(Vector<IssmDouble>* gradient,int weight_index,int control_index){
 
-	int        i,ig;
-	int        doflist1[NUMVERTICES];
-	IssmDouble     Jdet,weight;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     dbasis[NDOF2][NUMVERTICES];
-	IssmDouble     dk[NDOF2]; 
-	IssmDouble     grade_g[NUMVERTICES]={0.0};
+	int        i;
+	int        vertexpidlist[NUMVERTICES];
+	IssmDouble Jdet,weight;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble dbasis[NDOF2][NUMVERTICES];
+	IssmDouble dk[NDOF2]; 
+	IssmDouble grade_g[NUMVERTICES]={0.0};
 	GaussTria  *gauss=NULL;
 
 	/*Retrieve all inputs we will be needing: */
 	GetVerticesCoordinates(&xyz_list[0][0], nodes, NUMVERTICES);
-	GradientIndexing(&doflist1[0],control_index);
+	GradientIndexing(&vertexpidlist[0],control_index);
 	Input* rheologyb_input=material->inputs->GetInput(MaterialsRheologyBbarEnum); _assert_(rheologyb_input);
 	Input* weights_input=inputs->GetInput(InversionCostFunctionsCoefficientsEnum);                _assert_(weights_input);
@@ -3572,5 +3637,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -3586,5 +3651,5 @@
 		for (i=0;i<NUMVERTICES;i++) grade_g[i]+=-weight*Jdet*gauss->weight*(dbasis[0][i]*dk[0]+dbasis[1][i]*dk[1]);
 	}
-	gradient->SetValues(NUMVERTICES,doflist1,grade_g,ADD_VAL);
+	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
 
 	/*Clean up and return*/
@@ -3595,16 +3660,16 @@
 void  Tria::GradjZGradient(Vector<IssmDouble>* gradient,int weight_index,int control_index){
 
-	int        i,ig;
-	int        doflist1[NUMVERTICES];
-	IssmDouble     Jdet,weight;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     dbasis[NDOF2][NUMVERTICES];
-	IssmDouble     dk[NDOF2]; 
-	IssmDouble     grade_g[NUMVERTICES]={0.0};
+	int        i;
+	int        vertexpidlist[NUMVERTICES];
+	IssmDouble Jdet,weight;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble dbasis[NDOF2][NUMVERTICES];
+	IssmDouble dk[NDOF2]; 
+	IssmDouble grade_g[NUMVERTICES]={0.0};
 	GaussTria  *gauss=NULL;
 
 	/*Retrieve all inputs we will be needing: */
 	GetVerticesCoordinates(&xyz_list[0][0], nodes, NUMVERTICES);
-	GradientIndexing(&doflist1[0],control_index);
+	GradientIndexing(&vertexpidlist[0],control_index);
 	Input* rheologyz_input=material->inputs->GetInput(MaterialsRheologyZbarEnum); _assert_(rheologyz_input);
 	Input* weights_input=inputs->GetInput(InversionCostFunctionsCoefficientsEnum);                _assert_(weights_input);
@@ -3612,5 +3677,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -3626,5 +3691,5 @@
 		for (i=0;i<NUMVERTICES;i++) grade_g[i]+=-weight*Jdet*gauss->weight*(dbasis[0][i]*dk[0]+dbasis[1][i]*dk[1]);
 	}
-	gradient->SetValues(NUMVERTICES,doflist1,grade_g,ADD_VAL);
+	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
 
 	/*Clean up and return*/
@@ -3636,12 +3701,12 @@
 
 	/*Intermediaries*/
-	int        i,ig;
+	int        i;
 	int        doflist[NUMVERTICES];
-	IssmDouble     vx,vy,lambda,mu,thickness,Jdet;
-	IssmDouble     viscosity_complement;
-	IssmDouble     dvx[NDOF2],dvy[NDOF2],dadjx[NDOF2],dadjy[NDOF2],dB[NDOF2]; 
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     basis[3],epsilon[3];
-	IssmDouble     grad[NUMVERTICES]={0.0};
+	IssmDouble vx,vy,lambda,mu,thickness,Jdet;
+	IssmDouble viscosity_complement;
+	IssmDouble dvx[NDOF2],dvy[NDOF2],dadjx[NDOF2],dadjy[NDOF2],dB[NDOF2]; 
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble basis[3],epsilon[3];
+	IssmDouble grad[NUMVERTICES]={0.0};
 	GaussTria *gauss = NULL;
 
@@ -3660,5 +3725,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(4);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
